function detect_lines(filename)
%% read file
im=imread(filename);
im=imresize(im,.5);
if ndims(im)==3
    im=rgb2gray(im);
end
im=double(im);

%% detect edges
[E,M,O]=canny(im,.5,30,60);

%% smooth the orientations array using a simple 3x3 averaging mask
Os=myConvolution_ReflectingBoundaries(O,ones(3)/3^2);

%% compute Hough transform
A=hough_transform(E,Os);

%% smooth the accumulator array using a simple 9x9 averaging mask
%As=myConvolution_ReflectingBoundaries(A,ones(9)/9^2);

%% find local maxima in the accumulator array
local_maxima=find_local_maxima(A);

%% set adaptive threshold for votes via percentiles (ignore lines with 0 votes when computing the percentile)
th=prctile(A(A>0),99);

%% detect lines as local maxima of the accumulator array that also pass a threshold 
[r_index,theta_index]=find(local_maxima & A>th);

%% convert (r, theta) indices to (r, theta) values
%%%%%%%%% 
%%%%%%%%% For help on this part, look at hough_transform.m for the inverse
%%%%%%%%% computations (i.e., values to indices)
%%%%%%%%% 
max_r = round(sqrt(size(im,1)^2+size(im,2)^2));
r = ------------ADD_CODE_HERE------------;
theta = ------------ADD_CODE_HERE------------;

%% draw lines
result=im;
imagesc(result); colormap gray
for i=1:length(r)
    result=draw_line_polar(result,r(i),theta(i));
    imagesc(result);
    drawnow;
end
axis equal; axis tight; axis off;
colormap gray
print(gcf,[filename(1:end-4) '_lines.png'],'-dpng');