function A=hough_transform(Edge,Orientation)
 % Fill the accumulator array A corresponding to the Hough transform for
 % detecting lines in the edge image 'Edge'.

%% Determine size of the accumulator array A
 % Maximum possible perpendicular distance 'max_r' of a line that is 
 % "visible" in the image is the length of the image diagonal. Array A 
 % covers distances from -max_r to max_r
 % Angle theta ranges from 0 to -pi and from 0 to pi for total 360 degrees.
max_r = round(------------ADD_CODE_HERE------------);
nbins_theta = 360;
A = zeros(2*max_r+1,nbins_theta);

%% Get edge pixels
[rows,cols] = find(Edge~=0);

%% Find vote of every edge pixel in the Hough space (r,theta)
for i = 1:length(rows)
    x = rows(i);
    y = cols(i);
    % we already know the orientation of the line that is passing through point x,y
    theta = Orientation(x,y);
    %for theta=-pi:.001:pi  %otherwise we would need this loop to vote for lines of ALL orientations through x,y
        r = ------------ADD_CODE_HERE------------;    %find r for this x,y,theta
        r_index = round(r)+max_r+1;         %find index of r in A
        theta_index = mod(round(theta*180/pi+180),nbins_theta)+1;   %find index of theta in A
        A(r_index,theta_index) = A(r_index,theta_index)+1;  %vote for line r,theta
    %end
end
imwrite(myAffineRescaling(A),'A.png');